use crate::markups::deletion_markup;
use arrayvec::ArrayString;
use cryptography::passwords::generate_passwords;
use std::fmt::Write;
use teloxide::{adaptors::Throttle, prelude::*, types::ParseMode};
use tokio::task::spawn_blocking;

/// Handles /gen_password command by generating 10 copyable passwords and sending them to the user
pub async fn gen_password(bot: Throttle<Bot>, msg: Message) -> crate::Result<()> {
    let mut message: ArrayString<{ 10 + 35 * 10 }> = "Passwords:".try_into().unwrap();
    let passwords = spawn_blocking(generate_passwords).await?;
    for password in passwords {
        write!(message, "\n`{password}`").unwrap();
    }
    bot.send_message(msg.chat.id, message.as_str())
        .parse_mode(ParseMode::MarkdownV2)
        .reply_markup(deletion_markup())
        .await?;
    Ok(())
}
