//! This module consists of endpoints to handle commands

mod add_account;
mod cancel;
mod delete;
mod delete_all;
mod export;
mod gen_password;
mod get_account;
mod get_accounts;
mod help;
mod import;
mod set_master_pass;
mod start;

pub use add_account::add_account;
pub use cancel::cancel;
pub use delete::delete;
pub use delete_all::delete_all;
pub use export::export;
pub use gen_password::gen_password;
pub use get_account::get_account;
pub use get_accounts::get_accounts;
pub use help::help;
pub use import::import;
pub use set_master_pass::set_master_pass;
pub use start::start;
use teloxide::macros::BotCommands;

#[derive(BotCommands, Clone, Copy)]
#[command(
    rename_rule = "snake_case",
    description = "These commands are supported:"
)]
pub enum Command {
    #[command(description = "displays the welcome message")]
    Start,
    #[command(description = "displays this text")]
    Help,
    #[command(description = "sets the master password")]
    SetMasterPass,
    #[command(description = "adds the account")]
    AddAccount,
    #[command(description = "gets the account")]
    GetAccount,
    #[command(description = "gets a list of accounts")]
    GetAccounts,
    #[command(description = "deletes the account")]
    Delete,
    #[command(description = "deletes all the accounts and the master password")]
    DeleteAll,
    #[command(description = "exports all the accounts in a json file")]
    Export,
    #[command(description = "loads the accounts from a json file")]
    Import,
    #[command(description = "generates 10 secure passwords")]
    GenPassword,
    #[command(description = "cancels the current action")]
    Cancel,
}
